/*
   Multple Time Frame Trix T3 Indicator for THV System
   This Multiple Time Frame TRIX T3 is for MTF purposes
   The original TRIX T3 remains untouched (orginal by Luis Damiani)
   
   Make sure the variable (strBaseCodeFileName) is set to the Original Trix filename...
*/

#property copyright "Modified MTF Trix by Peter D."

#property indicator_separate_window

#property indicator_buffers     8
#property indicator_color1      Aquamarine     
#property indicator_color2      LightPink   
#property indicator_color3      Lime      
#property indicator_color4      Pink       
#property indicator_color5      Green       
#property indicator_color6      Red       
#property indicator_color7      Lime      
#property indicator_color8      Red       
//---- input parameters
extern string     TimeFrameInfo0 = "<<< Time Frame >>>";
extern bool       autoPair=true;
extern string     Pair = "GBPJPY";
extern int        TimeFrame = 0;
extern string     TimeFrameInfo1 = "";
extern string     TimeFrameInfo2 = "use: '0' for current timeframe";
extern string     TimeFrameInfo3 = "1->M1, 5->M5, 15->M15, 30->M30";
extern string     TimeFrameInfo4 = "60->H1, 240->H4, 1440->D1";
extern string     TimeFrameInfo5 = "10080->W1, 43200->MN1";
extern string     TimeFrameInfo6 = "or use auto=true for 1 period higher";
extern bool       autotimeframe=false;
extern bool       autotimeframe2=false;
extern bool       showhisto=true;
extern string     _ = "";
extern string     __ = "<<< Number of bars >>>";
extern int        TrixNumberOfBars=750;

extern string     ___ = "";
extern string     ____ = "<<< Trix settings >>>";
extern int        A_t3_period=20;
extern int        B_t3_period_ac=35;
extern color Color1=Silver;
extern color Color2=Aquamarine;
extern color Color3=LightPink;
extern color Color4=Silver;
extern int Line=2;
int               is_A_open_price=0;
int               diferential=0;
extern double            hot=1.2;

string strBaseCodeFileName = "THV T3 Trix";
string   indicatorName;
//---- Arrays for Trix values
double dblMain[];
double dblSignal[];

// Indicator Buffers //
double dblTrixFastUp[];
double dblTrixFastDown[];
double dblTrixSlowUp[];
double dblTrixSlowDown[];
double     ind_buffer1[];
double     ind_buffer2[];
double     ind_buffer3[];
double     ind_buffer4[];


//+------------------------------------------------------------------+
//| init()
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(4,DRAW_LINE);
   SetIndexBuffer(4,dblTrixFastUp);
   SetIndexStyle(5,DRAW_LINE);
   SetIndexBuffer(5,dblTrixFastDown);
   SetIndexStyle(6,DRAW_LINE);
   SetIndexBuffer(6,dblTrixSlowUp);
   SetIndexStyle(7,DRAW_LINE);
   SetIndexBuffer(7,dblTrixSlowDown);
   
   if(!SetIndexBuffer(3,ind_buffer1) &&
      !SetIndexBuffer(0,ind_buffer2) &&
      !SetIndexBuffer(1,ind_buffer3)  &&
      !SetIndexBuffer(2,ind_buffer4)  )
       Print("cannot set indicator buffers!");
  
  if (showhisto==true)
  {
   SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID, Line, Color2); //Green
   SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_SOLID, Line,Color3);//Red
   SetIndexStyle(2,DRAW_HISTOGRAM,STYLE_SOLID, Line,Color4);//Silver
   SetIndexStyle(3,DRAW_LINE,STYLE_SOLID, Line,Color3);//Silver
   }
   else if (showhisto==false)
   {
   SetIndexStyle(0,DRAW_NONE,STYLE_SOLID, Line, Color2); //Green
   SetIndexStyle(1,DRAW_NONE,STYLE_SOLID, Line,Color3);//Red
    SetIndexStyle(2,DRAW_NONE,STYLE_SOLID, Line,Color4);//Silver
     SetIndexStyle(3,DRAW_NONE,STYLE_SOLID, Line,Color4);//Silver
  
   }
   
//----

  if(autotimeframe==true)
   {
   TimeFrame=getPeriod();
   }
   
  if(autotimeframe2==true)
   {
   TimeFrame=getPeriod2();
   }
   
   string strTimeFrame = GetPeriodName(TimeFrame);
   indicatorName = "THV3 - MTF Trix (" + strTimeFrame + ")";
   IndicatorShortName(indicatorName);
//----

 
   
      return(0);
  }

//+------------------------------------------------------------------+
//| start()
//+------------------------------------------------------------------+
int start()
  {
   
  
   
   
   datetime dtmTime[];
   
   int j;
   int intMaxVal;
   int intTotBars = IndicatorCounted();

   intMaxVal = Bars - intTotBars;
   ArrayCopySeries(dtmTime, MODE_TIME, Symbol(), TimeFrame); 
   ArrayResize(dblMain, intMaxVal);ArrayResize(dblSignal, intMaxVal);
   
   
   
   
   j = 0;
   
   // Calculate TRIX Values //
   for(int i=0; i<intMaxVal; i++)
   {
      if (Time[i] < dtmTime[j]) j++; 
      
      if(autoPair==true)
      {
      dblMain[i]=iCustom(NULL, TimeFrame, strBaseCodeFileName, TrixNumberOfBars, A_t3_period, B_t3_period_ac,hot, MODE_MAIN, j);
      dblSignal[i]=iCustom(NULL, TimeFrame, strBaseCodeFileName, TrixNumberOfBars, A_t3_period, B_t3_period_ac,hot, MODE_SIGNAL, j);
      }
      else if (autoPair==false)
      {
       dblMain[i]=iCustom(Pair, TimeFrame, strBaseCodeFileName, TrixNumberOfBars, A_t3_period, B_t3_period_ac,hot, MODE_MAIN, j);
      dblSignal[i]=iCustom(Pair, TimeFrame, strBaseCodeFileName, TrixNumberOfBars, A_t3_period, B_t3_period_ac,hot, MODE_SIGNAL, j);
      }
     
     ind_buffer1[i]=dblMain[i]-  dblSignal[i];
     
    // Comment(DoubleToStr(ind_buffer1[i+1],6), " ",DoubleToStr(ind_buffer1[i],6));
   }

   // Coloring //
   for(i=intMaxVal-2; i>=0; i--)
   {
      dblTrixFastUp[i] = EMPTY_VALUE; dblTrixFastDown[i] = EMPTY_VALUE;
      dblTrixSlowUp[i] = EMPTY_VALUE; dblTrixSlowDown[i] = EMPTY_VALUE;
      ind_buffer3[i]= EMPTY_VALUE;
      ind_buffer2[i]= EMPTY_VALUE;
      ind_buffer4[i]= EMPTY_VALUE;
      if (dblMain[i+1] < dblMain[i])
      {
         if (dblTrixFastUp[i+1] == EMPTY_VALUE) dblTrixFastUp[i+1] = dblMain[i+1];
         dblTrixFastUp[i] = dblMain[i];
      }
      else if (dblMain[i+1]>dblMain[i])
      {
         if (dblTrixFastDown[i+1] == EMPTY_VALUE) dblTrixFastDown[i+1] = dblMain[i+1];
         dblTrixFastDown[i] = dblMain[i];
      }
      else
      {
         if (dblTrixFastUp[i+1]   != EMPTY_VALUE) dblTrixFastUp[i]   = dblTrixFastUp[i+1];
         if (dblTrixFastDown[i+1] != EMPTY_VALUE) dblTrixFastDown[i] = dblTrixFastDown[i+1];
      }

      if(dblSignal[i+1]<dblSignal[i])
      {
         if (dblTrixSlowUp[i+1] == EMPTY_VALUE) dblTrixSlowUp[i+1] = dblSignal[i+1];
         dblTrixSlowUp[i] = dblSignal[i];
      }   
      else if (dblSignal[i+1]>dblSignal[i])
      {
         if (dblTrixSlowDown[i+1] == EMPTY_VALUE) dblTrixSlowDown[i+1] = dblSignal[i+1];
         dblTrixSlowDown[i] = dblSignal[i];
      }
      else
      {
         if (dblTrixSlowUp[i+1]   != EMPTY_VALUE) dblTrixSlowUp[i]   = dblTrixSlowUp[i+1];
         if (dblTrixSlowDown[i+1] != EMPTY_VALUE) dblTrixSlowDown[i] = dblTrixSlowDown[i+1];
      }
      
      
      if (dblSignal[i]<dblMain[i] && dblMain[i+1]-  dblSignal[i+1]>dblMain[i]-  dblSignal[i])
      {
      ind_buffer3[i]=dblMain[i]-  dblSignal[i];
      }
      else if (dblSignal[i]<dblMain[i] && dblMain[i+1]-  dblSignal[i+1]<dblMain[i]-  dblSignal[i])
      {
       ind_buffer2[i]=dblMain[i]-  dblSignal[i];
      }
      else  if (dblSignal[i]>dblMain[i] && dblMain[i+1]-  dblSignal[i+1]<dblMain[i]-  dblSignal[i])
      {
      ind_buffer2[i]=ind_buffer1[i];
      }
      else if (dblSignal[i]>dblMain[i] && dblMain[i+1]-  dblSignal[i+1]>dblMain[i]-  dblSignal[i])
      {
       ind_buffer3[i]=ind_buffer1[i];
      }
      
     else{ind_buffer4[i]=dblMain[i]-  dblSignal[i];} 
      
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+

//-----------------------------------------------------------------------------//
//  Get TimeFrame
//-----------------------------------------------------------------------------//
string GetPeriodName(int intPeriod)
{
   string strPeriod = "unknown";

   if (intPeriod == PERIOD_M1)  strPeriod = "M1";
   if (intPeriod == PERIOD_M5)  strPeriod = "M5";
   if (intPeriod == PERIOD_M15) strPeriod = "M15";
   if (intPeriod == PERIOD_M30) strPeriod = "M30";
   if (intPeriod == PERIOD_H1)  strPeriod = "H1";
   if (intPeriod == PERIOD_H4)  strPeriod = "H4";
   if (intPeriod == PERIOD_D1)  strPeriod = "D1";
   if (intPeriod == PERIOD_W1)  strPeriod = "W1";
   if (intPeriod == PERIOD_MN1) strPeriod = "MN1";
   if (intPeriod == 0) strPeriod = GetPeriodName(Period());

   return(strPeriod);
}
int getPeriod()
  {
      int tf=0;
     
                switch(Period())
                  {
                    case 1:
                      tf=5;
                     
                      break;
                   case 5:
                      tf=15; 
                      
                      break;
                   case 15:
                      tf=30;  
                     
                      break;
                   case 30:
                      tf=60; 
                       
                      break;
                   case 60:
                     tf=240; 
                     
                      break;
                   case 240:
                      tf=1440;
                       
                      break;
                   case 1440:
                      tf=10080;
                      
                      break;
                   case 10080:
                      tf=43200;
                      
                      break;
                   case 43200:
                      tf=43200; 
                      
                      break;
                  }
           
         return(tf);
      }
      
      int getPeriod2()
  {
      int tf=0;
     
                switch(Period())
                  {
                    case 1:
                      tf=15;
                     
                      break;
                   case 5:
                      tf=30; 
                      
                      break;
                   case 15:
                      tf=60;  
                     
                      break;
                   case 30:
                      tf=240; 
                       
                      break;
                   case 60:
                     tf=1440; 
                     
                      break;
                   case 240:
                      tf=10080;
                       
                      break;
                   case 1440:
                      tf=43200;
                      
                      break;
                   case 10080:
                      tf=43200;
                      
                      break;
                   case 43200:
                      tf=43200; 
                      
                      break;
                  }
           
         return(tf);
      }